
 //+------------------------------------------------------------------+
 //|                                                                  |
 //|                         www.forexdyr.com                         |
 //|                         King_Prog                                |
 //+------------------------------------------------------------------+
   
#property copyright "King_Brog"
#property link      "www.forexdyr.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int k_period=5;
extern int d_period=3;
extern int slowing=3;
extern int method=0;
extern int price_field=0;
extern bool EnableAlert=true;
extern bool AlertOnlyWhenOverLevels=false;
extern double OverSold=20;
extern double OverBought=80;
extern bool EnableSendMail=false;
extern bool EnableComment=true;

datetime Timee;
datetime Timem;
double Up_Arrow[];
double Dn_Arrow[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,Up_Arrow);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(1,Dn_Arrow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
 {
  Comment("");
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
 { 
  if(EnableComment)Comment("King_Prog"+"\n"+"www.forexdyr.com");  
   
  int bars=Bars-IndicatorCounted();
  
  for(int i=1;i<=bars;i++)
  {
   int counter=i;
   int Range=0;
   int AvgRange=0;
   for (counter=i ;counter<=i+9;counter++)
   {
    AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
   }
   Range=AvgRange/10;
   double Stoch_Main=iStochastic(Symbol(),0,k_period,d_period,slowing,method,price_field,MODE_MAIN,i);   
   double Stoch_Signal=iStochastic(Symbol(),0,k_period,d_period,slowing,method,price_field,MODE_SIGNAL,i);
   double Stoch_Main_pr=iStochastic(Symbol(),0,k_period,d_period,slowing,method,price_field,MODE_MAIN,i+1);   
   double Stoch_Signal_pr=iStochastic(Symbol(),0,k_period,d_period,slowing,method,price_field,MODE_SIGNAL,i+1);
   
   if(Stoch_Main>Stoch_Signal&&Stoch_Main_pr<=Stoch_Signal_pr&&Stoch_Main_pr<=OverSold||!AlertOnlyWhenOverLevels)
   {
    Up_Arrow[i] = Low[i] - Range*0.5;
    if(Timee!=Time[0]&&Up_Arrow[1]<5000&&EnableAlert)
    {
     Alert("Stochsatic Cross Up : ",Symbol(),"  TimeFrame: ",Period()+"M");
     Timee=Time[0];
    }     
    if(EnableSendMail&&Timem!=Time[0])
     {
      SendMail("Stochastic Up Trend Crosses","Stochastic Up Trend Crosses "+Symbol()+" TimeFrame: "+Period());
      Timem=Time[0];
     }
   }
   if(Stoch_Main<Stoch_Signal&&Stoch_Main_pr>=Stoch_Signal_pr&&Stoch_Main_pr>=OverBought||!AlertOnlyWhenOverLevels)
   {
    Dn_Arrow[i] = High[i] + Range*0.5;
    if(Timee!=Time[0]&&Dn_Arrow[1]<5000&&EnableAlert)
    {
     Alert("Stochsatic Cross Down : ",Symbol(),"  TimeFrame: ",Period()+"M");
     Timee=Time[0];
    }   
    if(EnableSendMail&&Timem!=Time[0])
     {
      SendMail("Stochastic Down Trend Crosses","Stochastic Dn Trend Crosses "+Symbol()+" TimeFrame: "+Period());
      Timem=Time[0];
     }    
    }     
   }     
 }